/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import { DEFAULT_MONTHS } from '../constants.js';

const getDefaultMonthItems = formatMonthLabel => DEFAULT_MONTHS.map(month => ({
  id: month.toString(),
  label: formatMonthLabel(month)
}));

export const filterMonthItems = (monthItems, filterList) => monthItems.map(month => {
  if (!filterList.includes(Number(month.id))) {
    return { ...month,
      disabled: true
    };
  }

  return month;
});
export const getFilteredMonthItems = ({
  filterMonthsList,
  formatMonthLabel
}) => {
  let monthItems = getDefaultMonthItems(formatMonthLabel);

  if (filterMonthsList) {
    monthItems = filterMonthItems(monthItems, filterMonthsList);
  }

  return monthItems;
};